unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    tcp: TIdTCPClient;
    edport: TEdit;
    Label1: TLabel;
    edserver: TEdit;
    Label2: TLabel;
    Button1: TButton;
    Button2: TButton;
    ListBox1: TListBox;
    procedure docommand(cmd:string);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  moving:array [0..1000] of integer;   //tady si ukldm informace o tom, kam jakej vtah jede / kde je


implementation

{$R *.dfm}

procedure tform1.docommand(cmd:string);      //provede samotn pkaz
var _cmd,_parameters:string; //pouze pkaz, vechny parametry pkazu
    param1,param2:string;  //prvn a druhej parametr pkazu
    i:integer;   //ta
begin
  _cmd:=copy(cmd,1,pos(' ',cmd)-1);  //do _cmd ulo pkaz, a do _parameters ulo parametry pkazu
  _parameters:=copy(cmd,pos(' ',cmd)+1,length(cmd));  //uloim si vechny parametry
  _cmd:=lowercase(_cmd);   //pevedu pkaz na mal psmena
  param1:=copy(_parameters,1,pos(' ',_parameters)-1);  //uloim si pouze prvn parametr pkazu
  param2:=copy(_parameters,pos(' ',_parameters)+1,length(_parameters));  //uloim se ten druhej parametr pkazu (pop i tet, pokud je - ten si u odfiltruju zvl᚝...

  if _cmd='cabinbutton' then    //kdy bylo stisknuto tlatko v kabin....
  begin
    tcp.WriteLn('indion '+param1+' '+param2);   //rozsvtim indiktor kam jede
    tcp.WriteLn('close '+param1);  //pokusim se zavt dvee kabiny

    while _cmd<>'closed' do
    begin
      cmd:=tcp.readln(#13#10);
      _cmd:=copy(cmd,1,pos(' ',cmd)-1);  //do _cmd ulo pkaz, a do _parameters ulo parametry pkazu
      _cmd:=lowercase(_cmd);   //pevedu pkaz na mal psmena
      tcp.WriteLn('close '+param1);  //pokusim se zavt dvee kabiny
      if cmd<>'closed' then docommand(cmd)
    end;


    if moving[strtoint(param1)] > strtoint(param2) then    //jestli se pojede dolu
    begin
      tcp.writeln('speed '+param1+' 2000');   //polu vtah dolu
    end;
    if moving[strtoint(param1)] < strtoint(param2) then         //jestli nahoru
    begin
      tcp.writeln('speed '+param1+' -2000');   //polu vtah nahoru
    end;
    tcp.writeln('indioff '+param1+' '+inttostr(moving[strtoint(param1)]));  //jestli nkdo zmk tlatko za jzdy, zhasne indiktor v pate, kam jel pvodn
    moving[strtoint(param1)]:=strtoint(param2);   //zapu si, kam vtah jede
  end;
  if _cmd='level' then    //jestli se nachz vtah v uritm podla
  begin
    if moving[strtoint(param1)]=strtoint(param2) then   //podvm se, jestli to neni to podla do jakho jede
    begin
      tcp.WriteLn('speed '+param1+' 0');  //jestli jo, tak ho zastavim
      sleep(2500);  //pokm, a bude bezpen otevt kabinu
      tcp.WriteLn('indioff '+param1+' '+param2); //zhasne indiktor pohybu
      tcp.WriteLn('open '+param1);  //pokusim se zavt dvee kabiny

    end;

  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var in_command:string;    //string pro pchoz pkaz
begin
  tcp.Port:=strtoint(edport.text);   //nastavim port
  tcp.Host:=edserver.text;           //nastavim hostitelskej pota (server)
  tcp.Connect();  //pipojim se
  if tcp.Connected then        //jestli se pipojen zdailo
  begin
    form1.caption:='Vtahy - Pipojeno k serveru '+edserver.text+':'+edport.text;  //napu to do captionu formu
    button1.Enabled:=false;   //zaku button pro pipojen
    button2.enabled:=true;    //povolim button pro odpojen
  end;
  while tcp.connected do   //dokud sem pipojenej     
  begin
    in_command:=tcp.readln(#13#10,1,-1);   //pokm si jeslti nco nepilo
    listbox1.Items.add(in_command);   //to si zapu do logu
    if in_command<>'' then   //jeslti to nebyl przdnej dek
      docommand(in_command);   //polu to procedue docommand, kter to vykone
    application.ProcessMessages;   //pedm zen windows, aby obslouili udlosti jako je pesun okna atd.
  end;

end;

procedure TForm1.Button2Click(Sender: TObject);
begin
  tcp.Disconnect;  //odpojim se
  if not tcp.connected then    //jetli sem se odpojil
  begin
    form1.caption:='Vtahy';   //nap do captionu formu "vtahy"
    button2.Enabled:=false;   //zaku button pro odpojen
    button1.enabled:=true;    //povolim button pro pipojen
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if tcp.Connected then tcp.Disconnect;  //jestli sem pipojenej, tak se odpojim
end;

end.
